/*Originally be Alex "Lex" Evans, alxevans@concentric.net
 *data alignment and register unsigned short hacks by Willard Goosey,
 *goosey@mailhost.nmt.edu
 */

/*default machine is 680[34]0 Amiga with gcc*/
/*#define ATT7300  /*AT&T 3b1 UNIX PC 7300 */
/*#define SUN4   /*Sun 4, sunos4.1.3 OR Solaris 5.7*/
/*#define NEXT  /*NeXTStep 3.3 w/ gcc */
/*#define PPC  /*Motorola Power PC running PPC-linux w/ gcc*/
/*#define X86 /*Linux x86*/
/*#define ALPHA /*DEC Alpha */

/*#define NOSHORT    /*define if register unsigned short won't compile */
/*#define ALIGN    /*define if your processor requires data alignment */

#include <stdio.h>
#include <time.h>

#ifdef ATT7300
#define ALIGN
#define NOSHORT
#include <sys/types.h>    /*time.h doesn't define time_t on the Unix PC*/
#endif

#ifdef SUN4
#define NOSHORT
#define ALIGN
#endif

#ifdef NEXT
#define NOSHORT
#endif

#ifdef PPC
/*works fine!*/
#endif



#ifdef X86
#define NOSHORT
#endif

#ifdef ALPHA
#define NOSHORT
#endif

int mode;
unsigned char i0, i1;
unsigned char memory[65539];

#define UNIM	00
#define PRE1	10
#define PRE2	11
#define IMMB	21
#define IMMW	22
#define IMML	23
#define DIRA	30
#define DIRB	31
#define DIRW	32
#define DIRL	33
#define EXTA	40
#define EXTB	41
#define EXTW	42
#define EXTL	43
#define INDA	50
#define INDB	51
#define INDW	52
#define INDL	53
#define INH0	60
#define INHB	61
#define INHW	62
#define INHL	63
#define RELB	71
#define RELW	72
#define REGS	81

#define A	(reg.un.bt.a)
#define B	(reg.un.bt.b)
#define CC	(reg.cc)
#define D	(reg.un.wd.d)
#define DP	(dp)
#define E	(reg.un.bt.e)
#define F	(reg.un.bt.f)
#define MD	(reg.md)
#define PC	(pc)
#define Q	(reg.un.lw.q)
#define S	(s)
#define U	(u)
#define V	(v)
#define W	(reg.un.wd.w)
#define X	(x)
#define Y	(y)
#define btst(A, B)	(((A)&0x01<<(B))!=0)
#define bset(A, B)	(A)|=0x01<<(B)

#ifdef ALIGN       	/*for MC68000, 68010, SPARC, etc*/

short wfetch(a)
{
   return (short)((memory[a]<<8)|(memory[(a+1)]));
}
short wstore(a,b)
      short b;
{
    memory[a]=(unsigned char)(b >> 8); 
    memory[(a+1)]=(unsigned char)(b);
    return b;
}
long lfetch(a)
{
    long temp;
    temp = (long)(((unsigned char)memory[a])<<24);
    temp = temp | (long)(((unsigned char)memory[a+1])<<16);
    temp = temp | (long)(((unsigned char)memory[a+2])<<8);
    temp = temp | (long)(((unsigned char)memory[a+3]));
    return temp;
}

long lstore(a,b)
     long b;
{
    memory[a]=(b>>24);
    memory[a+1]=(b>>16);
    memory[a+2]=(b>>8);
    memory[a+3]=(b);
    return b;
}


#else

#define wfetch(A)	(*(short *)(&memory[A]))	/* note that these need to be changed for a 68000 or 68010 based machine */
#define wstore(A, B)	(*(short *)(&memory[A])=(B))	/* but it will not cause problems on a 68008 */
#define lfetch(A)	(*(long *)(&memory[A]))
#define lstore(A, B)	(*(long *)(&memory[A])=(B))

#endif

unsigned char fetch_operand();
unsigned short fetch_word_operand();
unsigned short fetch_effective_address();

char mode00[]={
	DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,DIRA,	/* $00 */
	PRE1,PRE2,INH0,INH0,INH0,UNIM,RELW,RELW,UNIM,INH0,IMMB,UNIM,IMMB,INH0,REGS,REGS,	/* $10 */
	RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,RELB,	/* $20 */
	INDA,INDA,INDA,INDA,INHB,INHB,INHB,INHB,UNIM,INH0,INH0,INH0,INH0,INH0,UNIM,INH0,	/* $30 */
	INH0,UNIM,UNIM,INH0,INH0,UNIM,INH0,INH0,INH0,INH0,INH0,UNIM,INH0,INH0,UNIM,INH0,	/* $40 */
	INH0,UNIM,UNIM,INH0,INH0,UNIM,INH0,INH0,INH0,INH0,INH0,UNIM,INH0,INH0,UNIM,INH0,	/* $50 */
	INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,INDA,	/* $60 */
	EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,EXTA,	/* $70 */
	IMMB,IMMB,IMMB,IMMB,IMMB,IMMB,IMMB,UNIM,IMMB,IMMB,IMMB,IMMB,IMMW,RELB,IMMW,UNIM,	/* $80 */
	DIRB,DIRB,DIRB,DIRB,DIRB,DIRB,DIRB,DIRA,DIRB,DIRB,DIRB,DIRB,DIRW,DIRA,DIRW,DIRA,	/* $90 */
	INDB,INDB,INDB,INDB,INDB,INDB,INDB,INDA,INDB,INDB,INDB,INDB,INDW,INDA,INDW,INDA,	/* $A0 */
	EXTB,EXTB,EXTB,EXTB,EXTB,EXTB,EXTB,EXTA,EXTB,EXTB,EXTB,EXTB,EXTW,EXTA,EXTW,EXTA,	/* $B0 */
	IMMB,IMMB,IMMB,IMMW,IMMB,IMMB,IMMB,UNIM,IMMB,IMMB,IMMB,IMMB,IMMW,IMML,IMMW,UNIM,	/* $C0 */
	DIRB,DIRB,DIRB,DIRW,DIRB,DIRB,DIRB,DIRA,DIRB,DIRB,DIRB,DIRB,DIRW,DIRA,DIRW,DIRA,	/* $D0 */
	INDB,INDB,INDB,INDW,INDB,INDB,INDB,INDA,INDB,INDB,INDB,INDB,INDW,INDA,INDW,INDA,	/* $E0 */
	EXTB,EXTB,EXTB,EXTW,EXTB,EXTB,EXTB,EXTA,EXTB,EXTB,EXTB,EXTB,EXTW,EXTA,EXTW,EXTA		/* $F0 */
    };
char mode10[]={
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1000 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1010 */
	UNIM,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,RELW,	/* $1020 */
	REGS,REGS,REGS,REGS,REGS,REGS,REGS,REGS,INH0,INH0,INH0,INH0,UNIM,UNIM,UNIM,INH0,	/* $1030 */
	INH0,UNIM,UNIM,INH0,INH0,UNIM,INH0,INH0,INH0,INH0,INH0,UNIM,INH0,INH0,UNIM,INH0,	/* $1040 */
	UNIM,UNIM,UNIM,INH0,INH0,UNIM,INH0,UNIM,UNIM,INH0,INH0,UNIM,INH0,INH0,UNIM,INH0,	/* $1050 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1060 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1070 */
	IMMW,IMMW,IMMW,IMMW,IMMW,IMMW,IMMW,UNIM,IMMW,IMMW,IMMW,IMMW,IMMW,UNIM,IMMW,UNIM,	/* $1080 */
	DIRW,DIRW,DIRW,DIRW,DIRW,DIRW,DIRW,DIRA,DIRW,DIRW,DIRW,DIRW,DIRW,UNIM,DIRW,DIRA,	/* $1090 */
	INDW,INDW,INDW,INDW,INDW,INDW,INDW,INDA,INDW,INDW,INDW,INDW,INDW,UNIM,INDW,INDA,	/* $10A0 */
	EXTW,EXTW,EXTW,EXTW,EXTW,EXTW,EXTW,EXTA,EXTW,EXTW,EXTW,EXTW,EXTW,UNIM,EXTW,EXTA,	/* $10B0 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,IMMW,UNIM,	/* $10C0 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,DIRL,DIRA,DIRW,DIRA,	/* $10D0 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,INDL,INDA,INDW,INDA,	/* $10E0 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,EXTL,EXTA,EXTW,EXTA 	/* $10F0 */
    };
char mode11[]={
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1100 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1110 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1120 */
	INHW,INHW,INHW,INHW,INHW,INHW,INHW,INHW,REGS,REGS,REGS,REGS,IMMB,IMMB,UNIM,INH0,	/* $1130 */
	UNIM,UNIM,UNIM,INH0,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,INH0,UNIM,INH0,INH0,UNIM,INH0,	/* $1140 */
	UNIM,UNIM,UNIM,INH0,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,INH0,UNIM,INH0,INH0,UNIM,INH0,	/* $1150 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1160 */
	UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,UNIM,	/* $1170 */
	IMMB,IMMB,UNIM,IMMW,UNIM,UNIM,IMMB,UNIM,UNIM,UNIM,UNIM,IMMB,IMMW,IMMB,IMMW,IMMW,	/* $1180 */
	DIRB,DIRB,UNIM,DIRW,UNIM,UNIM,DIRB,DIRA,UNIM,UNIM,UNIM,DIRB,DIRW,DIRB,DIRW,DIRW,	/* $1190 */
	INDB,INDB,UNIM,INDW,UNIM,UNIM,INDB,INDA,UNIM,UNIM,UNIM,INDB,INDW,INDB,INDW,INDW,	/* $11A0 */
	EXTB,EXTB,UNIM,DIRW,UNIM,UNIM,EXTB,EXTA,UNIM,UNIM,UNIM,EXTB,DIRW,EXTB,DIRW,DIRW,	/* $11B0 */
	IMMB,IMMB,UNIM,UNIM,UNIM,UNIM,IMMB,UNIM,UNIM,UNIM,UNIM,IMMB,UNIM,UNIM,UNIM,UNIM,	/* $11C0 */
	DIRB,DIRB,UNIM,UNIM,UNIM,UNIM,DIRB,DIRA,UNIM,UNIM,UNIM,DIRB,UNIM,UNIM,UNIM,UNIM,	/* $11D0 */
	INDB,INDB,UNIM,UNIM,UNIM,UNIM,INDB,INDA,UNIM,UNIM,UNIM,INDB,UNIM,UNIM,UNIM,UNIM,	/* $11E0 */
	EXTB,EXTB,UNIM,UNIM,UNIM,UNIM,EXTB,EXTA,UNIM,UNIM,UNIM,EXTB,UNIM,UNIM,UNIM,UNIM		/* $11F0 */
    };

unsigned char rlen[]={ 2,2,2,2,2,2,2,2,1,1,1,1,0,0,1,1 };

struct {
    union {
	unsigned char all;
	struct { unsigned char c:1,v:1,z:1,n:1,i:1,h:1,f:1,e:1; } bit;
    } cc;
    union {
	unsigned char all;
	struct { unsigned char dz:1,ii:1,rest:4,fm:1,em:1; } bit;
    } md;
    union {
	struct { unsigned long q; } lw;
	struct { unsigned short d, w; } wd;
	struct { unsigned char a, b, e, f; } bt;
	} un ;
} reg;

#ifdef NOSHORT
   unsigned short pc;
   unsigned char dp;
   unsigned short s, u, y, x, v;
#else
   register unsigned short pc;
   register unsigned char dp;
   register unsigned short s, u, y, x, v;
#endif

main()
{
    FILE *core;
    int i;
    time_t start, end;

    if((core=fopen("core", "rb"))==NULL) /*file test added by Willard*/
    {
       fprintf(stderr,"Could not open file core\n");
       exit(1);
    }
    for(i=0; i<65536; i++) memory[i]=getc(core);
    fclose(core);
    PC = memory[0xfffe]<<8 | memory[0xffff];
    DP = 0;
    MD.all = 0x00;
    CC.all = 0x0a;
    time(&start);
    execute();
    time(&end);
    state();
    if((core=fopen("core.out", "wb"))==NULL) /*file test added by Willard*/
    {
       fprintf(stderr,"Could not open file core.out\n");
       exit(1);
    }
    for(i=0; i<65536; i++) putc(memory[i], core);
    fclose(core);
    printf("Time elapsed %d seconds\n", end-start);
}

execute()
{
    void *rl1, *rl2;
    unsigned char mub, lsn, msn, r1, r2;
    char msb;
    unsigned short muw, addr;
    short msw;
    unsigned long mul;
    long msl;
    union {
	struct {
	    unsigned long a;
	} l;
	struct {
	    unsigned short a, e;
	} w;
	struct {
	    unsigned char a, c, e, g;
	} b;
	struct {
	    unsigned char a:4, b:4, c:4, d:4, e:4, f:4, g:4, h:4;
	} n;
    } post;

    for(;;) {
	switch(i0=memory[PC++]) {
	  case 0x10:
	    mode=mode10[i1=memory[PC++]];
	    break;
	  case 0x11:
	    mode=mode11[i1=memory[PC++]];
	    break;
	  default:
	    mode=mode00[i0];
	}

	switch(mode) {
	  case IMMB:	/* #$XX */
	  case INHB:	/* inherent byte */
	    post.b.a=memory[PC++];
	    break;
	  case IMMW:	/* #$XXXX */
	  case EXTA:	/* >$XXXX (address) */
	  case INHW:	/* inherent word */
	    post.w.a=wfetch((PC+=2)-2);
	    break;
	  case IMML:	/* #$XXXXXXXX */
	  case INHL:	/* inherent long */
	    post.l.a=lfetch((PC+=4)-4);
	    break;
	  case DIRA:	/* <$XX (address) */
	    post.b.a=DP;
	    post.b.c=memory[PC++];
	    break;
	  case DIRB:	/* <$XX (byte) /
	    post.b.a=DP;
	    post.b.c=memory[PC++];
	    post.b.a=memory[post.w.a];
	    break;
	  case DIRW:	/* <$XX (word) */
	    post.b.a=DP;
	    post.b.c=memory[PC++];
	    post.w.a=wfetch(post.w.a);
	    break;
	  case DIRL:	/* <$XX (long) */
	    post.b.a=DP;
	    post.b.c=memory[PC++];
	    post.l.a=lfetch(post.w.a);
	    break;
	  case EXTB:	/* >$XXXX (byte) */
	    post.b.a=memory[wfetch((PC+=2)-2)];
	    break;
	  case EXTW:	/* >$XXXX (word) */
	    post.w.a=wfetch(wfetch((PC+=2)-2));
	    break;
	  case EXTL:	/* >$XXXX (long) */
	    post.l.a=lfetch(wfetch((PC+=2)-2));
	    break;
	  case INDA:	/* indexed address */
	    post.b.a=memory[PC++];
	    if (post.b.a&0x80)
		switch(post.b.a) {
		  case 0x80:	/* ,x+ */
		    post.w.a=X++;
		    break;
		  case 0x81:	/* ,x++ */
		    post.w.a=(X+=2)-2;
		    break;
		  case 0x82:	/* ,-x */
		    post.w.a=--X;
		    break;
		  case 0x83:	/* ,--x */
		    post.w.a=X-=2;
		    break;
		  case 0x84:	/* ,x */
		    post.w.a=X;
		    break;
		  case 0x85:	/* b,x */
		    post.w.a=X+(char) B;
		    break;
		  case 0x86:	/* a,x */
		    post.w.a=X+(char) A;
		    break;
		  case 0x88:	/* $XX,x */
		    post.w.a=X+(char) memory[PC++];
		    break;
		  case 0x89:	/* $XXXX,x */
		    post.w.a=X+wfetch((PC+=2)-2);
		    break;
		  case 0x8b:	/* d,x */
		    post.w.a=X+D;
		    break;
		  case 0x8c: case 0xac: case 0xcc: case 0xec:	/* $XX,pc */
		    post.b.a=memory[PC++];
		    post.w.a=PC+post.b.a;
		    break;
		  case 0x8d: case 0xad: case 0xcd: case 0xed:	/* $XXXX,pc */
		    post.w.a=wfetch((PC+=2)-2);
		    post.w.a=PC+post.w.a;
		    break;
		  case 0x91:	/* [,x++] */
		    post.w.a=wfetch((X+=2)-2);
		    break;
		  case 0x93:	/* [,--x] */
		    post.w.a=wfetch(X-=2);
		    break;
		  case 0x94:	/* [,x] */
		    post.w.a=wfetch(X);
		    break;
		  case 0x95:	/* [b,x] */
		    post.w.a=wfetch(X+(char) B);
		    break;
		  case 0x96:	/* [a,x] */
		    post.w.a=wfetch(X+(char) A);
		    break;
		  case 0x98:	/* [$XX,x] */
		    post.w.a=wfetch(X+(char) memory[PC++]);
		    break;
		  case 0x99:	/* [$XXXX,x] */
		    post.w.a=wfetch(X+wfetch((PC+=2)-2));
		    break;
		  case 0x9b:	/* [d,x] */
		    post.w.a=wfetch(X+D);
		    break;
		  case 0x9c: case 0xbc: case 0xdc: case 0xfc:	/* [$XX,pc] */
		    post.b.a=memory[PC++];
		    post.w.a=wfetch(PC+(char) post.b.a);
		    break;
		  case 0x9d: case 0xbd: case 0xdd: case 0xfd:	/* [$XXXX,pc] */
		    post.w.a=wfetch((PC+=2)-2);
		    post.w.a=wfetch(PC+post.w.a);
		    break;
		  case 0x9f: case 0xbf: case 0xdf: case 0xff:	/* [$XXXX] */
		    post.w.a=wfetch(wfetch((PC+=2)-2));
		    break;
		  case 0xa0:	/* ,y+ */
		    post.w.a=Y++;
		    break;
		  case 0xa1:	/* ,y++ */
		    post.w.a=(Y+=2)-2;
		    break;
		  case 0xa2:	/* ,-y */
		    post.w.a=--Y;
		    break;
		  case 0xa3:	/* ,--y */
		    post.w.a=Y-=2;
		    break;
		  case 0xa4:	/* ,y */
		    post.w.a=Y;
		    break;
		  case 0xa5:	/* b,y */
		    post.w.a=Y+(char) B;
		    break;
		  case 0xa6:	/* a,y */
		    post.w.a=Y+(char) A;
		    break;
		  case 0xa8:	/* $XX,y */
		    post.w.a=Y+(char) memory[PC++];
		    break;
		  case 0xa9:	/* $XXXX,y */
		    post.w.a=Y+wfetch((PC+=2)-2);
		    break;
		  case 0xab:	/* d,y */
		    post.w.a=Y+D;
		    break;
		  case 0xb1:	/* [,y++] */
		    post.w.a=wfetch((Y+=2)-2);
		    break;
		  case 0xb3:	/* [,--y] */
		    post.w.a=wfetch(Y-=2);
		    break;
		  case 0xb4:	/* [,y] */
		    post.w.a=wfetch(Y);
		    break;
		  case 0xb5:	/* [b.y] */
		    post.w.a=wfetch(Y+(char) B);
		    break;
		  case 0xb6:	/* [a,y] */
		    post.w.a=wfetch(Y+(char) A);
		    break;
		  case 0xb8:	/* [$XX,y] */
		    post.w.a=wfetch(Y+(char) memory[PC++]);
		    break;
		  case 0xb9:	/* [$XXXX,y] */
		    post.w.a=wfetch(Y+wfetch((PC+=2)-2));
		    break;
		  case 0xbb:	/* [d,y] */
		    post.w.a=wfetch(Y+D);
		    break;
		  case 0xc0:	/* ,s+ */
		    post.w.a=S++;
		    break;
		  case 0xc1:	/* ,s++ */
		    post.w.a=(S+=2)-2;
		    break;
		  case 0xc2:	/* ,-s */
		    post.w.a=--S;
		    break;
		  case 0xc3:	/* ,--s */
		    post.w.a=S-=2;
		    break;
		  case 0xc4:	/* ,s */
		    post.w.a=S;
		    break;
		  case 0xc5:	/* b.s */
		    post.w.a=S+(char) B;
		    break;
		  case 0xc6:	/* a,s */
		    post.w.a=S+(char) A;
		    break;
		  case 0xc8:	/* $XX,s */
		    post.w.a=S+(char) memory[PC++];
		    break;
		  case 0xc9:	/* $XXXX,s */
		    post.w.a=S+wfetch((PC+=2)-2);
		    break;
		  case 0xcb:	/* d,s */
		    post.w.a=S+D;
		    break;
		  case 0xd1:	/* [,s++] */
		    post.w.a=wfetch((S+=2)-2);
		    break;
		  case 0xd3:	/* [,--s] */
		    post.w.a=wfetch(S-=2);
		    break;
		  case 0xd4:	/* [,s] */
		    post.w.a=wfetch(S);
		    break;
		  case 0xd5:	/* [b,s] */
		    post.w.a=wfetch(S+(char) B);
		    break;
		  case 0xd6:	/* [a,s] */
		    post.w.a=wfetch(S+(char) A);
		    break;
		  case 0xd8:	/* [$XX,s] */
		    post.w.a=wfetch(S+(char) memory[PC++]);
		    break;
		  case 0xd9:	/* [$XXXX,s] */
		    post.w.a=wfetch(S+wfetch((PC+=2)-2));
		    break;
		  case 0xdb:	/* [d,s] */
		    post.w.a=wfetch(S+D);
		    break;
		  case 0xe0:	/* ,u+ */
		    post.w.a=U++;
		    break;
		  case 0xe1:	/* ,u++ */
		    post.w.a=(U+=2)-2;
		    break;
		  case 0xe2:	/* ,-u */
		    post.w.a=--U;
		    break;
		  case 0xe3:	/* ,--u */
		    post.w.a=U-=2;
		    break;
		  case 0xe4:	/* ,u */
		    post.w.a=U;
		    break;
		  case 0xe5:	/* b,u */
		    post.w.a=U+(char) B;
		    break;
		  case 0xe6:	/* a,u */
		    post.w.a=U+(char) A;
		    break;
		  case 0xe8:	/* $XX,u */
		    post.w.a=U+(char) memory[PC++];
		    break;
		  case 0xe9:	/* $XXXX,u */
		    post.w.a=U+wfetch((PC+=2)-2);
		    break;
		  case 0xeb:	/* d,u */
		    post.w.a=U+D;
		    break;
		  case 0xf1:	/* [,u++] */
		    post.w.a=wfetch((U+=2)-2);
		    break;
		  case 0xf3:	/* [,--u] */
		    post.w.a=wfetch(U-=2);
		    break;
		  case 0xf4:	/* [,u] */
		    post.w.a=wfetch(U);
		    break;
		  case 0xf5:	/* [b,u] */
		    post.w.a=wfetch(U+(char) B);
		    break;
		  case 0xf6:	/* [a,u] */
		    post.w.a=wfetch(U+(char) A);
		    break;
		  case 0xf8:	/* [$XX,u] */
		    post.w.a=wfetch(U+(char) memory[PC++]);
		    break;
		  case 0xf9:	/* [$XXXX,u] */
		    post.w.a=wfetch(U+wfetch((PC+=2)-2));
		    break;
		  case 0xfb:	/* [d,u] */
		    post.w.a=wfetch(U+D);
		    break;
		  default:	/* unimplemented mode */
		    unimp("Illegal Indexed Addressing Mode");
		}
	    else /* !post.b.a&0x80 */ {
		post.w.e=post.b.a&0x1f;
		if (post.b.a&0x10) post.w.e |= 0xfff0;
		switch(post.b.a&0x60) {
		  case 0x00:	/* $XX,x (5-bit) */
		    post.w.a=X+post.w.e;
		    break;
		  case 0x20:	/* $XX,y (5-bit) */
		    post.w.a=Y+post.w.e;
		    break;
		  case 0x40:	/* $XX,s (5-bit) */
		    post.w.a=S+post.w.e;
		    break;
		  case 0x6:	/* $XX,u (5-bit) */
		    post.w.a=U+post.w.e;
		    break;
		}
	    }
	    break;
	  case INDB:	/* indexed (byte) */
	    post.b.a=memory[PC++];
	    if (post.b.a&0x80)
		switch(post.b.a) {
		  case 0x80:	/* ,x+ */
		    post.b.a=memory[X++];
		    break;
		  case 0x81:	/* ,x++ */
		    post.b.a=memory[(X+=2)-2];
		    break;
		  case 0x82:	/* ,-x */
		    post.b.a=memory[--X];
		    break;
		  case 0x83:	/* ,--x */
		    post.b.a=memory[X-=2];
		    break;
		  case 0x84:	/* ,x */
		    post.b.a=memory[X];
		    break;
		  case 0x85:	/* b,x */
		    post.b.a=memory[X+(char) B];
		    break;
		  case 0x86:	/* a,x */
		    post.b.a=memory[X+(char) A];
		    break;
		  case 0x88:	/* $XX,x */
		    post.b.a=memory[X+(char) memory[PC++]];
		    break;
		  case 0x89:	/* $XXXX,x */
		    post.b.a=memory[X+wfetch((PC+=2)-2)];
		    break;
		  case 0x8b:	/* d,x */
		    post.b.a=memory[X+D];
		    break;
		  case 0x8c: case 0xac: case 0xcc: case 0xec:	/* $XX,pc */
		    post.b.a=memory[PC++];
		    post.b.a=memory[PC+(char) post.b.a];
		    break;
		  case 0x8d: case 0xad: case 0xcd: case 0xed:	/* $XXXX,pc */
		    post.w.a=wfetch((PC+=2)-2);
		    post.b.a=memory[PC+post.w.a];
		    break;
		  case 0x91:	/* [,x++] */
		    post.b.a=memory[wfetch((X+=2)-2)];
		    break;
		  case 0x93:	/* [,--x] */
		    post.b.a=memory[wfetch(X-=2)];
		    break;
		  case 0x94:	/* [,x] */
		    post.b.a=memory[wfetch(X)];
		    break;
		  case 0x95:	/* [b.x] */
		    post.b.a=memory[wfetch(X+(char) B)];
		    break;
		  case 0x96:	/* [a,x] */
		    post.b.a=memory[wfetch(X+(char) A)];
		    break;
		  case 0x98:	/* [$XX,x] */
		    post.b.a=memory[wfetch(X+(char) memory[PC++])];
		    break;
		  case 0x99:	/* [$XXXX,x] */
		    post.b.a=memory[wfetch(X+wfetch((PC+=2)-2))];
		    break;
		  case 0x9b:	/* [d,x] */
		    post.b.a=memory[wfetch(X+D)];
		    break;
		  case 0x9c: case 0xbc: case 0xdc: case 0xfc:	/* [$XX,pc] */
		    post.b.a=memory[PC++];
		    post.b.a=memory[wfetch(PC+(char) post.b.a)];
		    break;
		  case 0x9d: case 0xbd: case 0xdd: case 0xfd:	/* [$XXXX,pc] */
		    post.w.a=wfetch((PC+=2)-2);
		    post.b.a=memory[wfetch(PC+post.w.a)];
		    break;
		  case 0x9f: case 0xbf: case 0xdf: case 0xff:	/* [$XXXX] */
		    post.b.a=memory[wfetch(wfetch((PC+=2)-2))];
		    break;
		  case 0xa0:	/* ,y+ */
		    post.b.a=memory[Y++];
		    break;
		  case 0xa1:	/* ,y++ */
		    post.b.a=memory[(Y+=2)-2];
		    break;
		  case 0xa2:	/* ,-y */
		    post.b.a=memory[--Y];
		    break;
		  case 0xa3:	/* ,--y */
		    post.b.a=memory[Y-=2];
		    break;
		  case 0xa4:	/* ,y */
		    post.b.a=memory[Y];
		    break;
		  case 0xa5:	/* b.y */
		    post.b.a=memory[Y+(char) B];
		    break;
		  case 0xa6:	/* a,y */
		    post.b.a=memory[Y+(char) A];
		    break;
		  case 0xa8:	/* $XX,y */
		    post.b.a=memory[Y+(char) memory[PC++]];
		    break;
		  case 0xa9:	/* $XXXX,y */
		    post.b.a=memory[Y+wfetch((PC+=2)-2)];
		    break;
		  case 0xab:	/* d,y */
		    post.b.a=memory[Y+D];
		    break;
		  case 0xb1:	/* [,y++] */
		    post.b.a=memory[wfetch((Y+=2)-2)];
		    break;
		  case 0xb3:	/* [,--y] */
		    post.b.a=memory[wfetch(Y-=2)];
		    break;
		  case 0xb4:	/* [,y] */
		    post.b.a=memory[wfetch(Y)];
		    break;
		  case 0xb5:	/* [b,y] */
		    post.b.a=memory[wfetch(Y+(char) B)];
		    break;
		  case 0xb6:	/* [a,y] */
		    post.b.a=memory[wfetch(Y+(char) A)];
		    break;
		  case 0xb8:	/* [$XX,y] */
		    post.b.a=memory[wfetch(Y+(char) memory[PC++])];
		    break;
		  case 0xb9:	/* [$XXXX,y] */
		    post.b.a=memory[wfetch(Y+wfetch((PC+=2)-2))];
		    break;
		  case 0xbb:	/* [d,y] */
		    post.b.a=memory[wfetch(Y+D)];
		    break;
		  case 0xc0:	/* ,s+ */
		    post.b.a=memory[S++];
		    break;
		  case 0xc1:	/* ,s++ */
		    post.b.a=memory[(S+=2)-2];
		    break;
		  case 0xc2:	/* ,-s */
		    post.b.a=memory[--S];
		    break;
		  case 0xc3:	/* ,--s */
		    post.b.a=memory[S-=2];
		    break;
		  case 0xc4:	/* ,s */
		    post.b.a=memory[S];
		    break;
		  case 0xc5:	/* b.s */
		    post.b.a=memory[S+(char) B];
		    break;
		  case 0xc6:	/* a,s */
		    post.b.a=memory[S+(char) A];
		    break;
		  case 0xc8:	/* $XX,s */
		    post.b.a=memory[S+(char) memory[PC++]];
		    break;
		  case 0xc9:	/* $XXXX,s */
		    post.b.a=memory[S+wfetch((PC+=2)-2)];
		    break;
		  case 0xcb:	/* d,s */
		    post.b.a=memory[S+D];
		    break;
		  case 0xd1:	/* [,s++] */
		    post.b.a=memory[wfetch((S+=2)-2)];
		    break;
		  case 0xd3:	/* [,--s] */
		    post.b.a=memory[wfetch(S-=2)];
		    break;
		  case 0xd4:	/* [,s] */
		    post.b.a=memory[wfetch(S)];
		    break;
		  case 0xd5:	/* [b,s] */
		    post.b.a=memory[wfetch(S+(char) B)];
		    break;
		  case 0xd6:	/* [a,s] */
		    post.b.a=memory[wfetch(S+(char) A)];
		    break;
		  case 0xd8:	/* [$XX,s] */
		    post.b.a=memory[wfetch(S+(char) memory[PC++])];
		    break;
		  case 0xd9:	/* [$XXXX,s] */
		    post.b.a=memory[wfetch(S+wfetch((PC+=2)-2))];
		    break;
		  case 0xdb:	/* [d,s] */
		    post.b.a=memory[wfetch(S+D)];
		    break;
		  case 0xe0:	/* ,u+ */
		    post.b.a=memory[U++];
		    break;
		  case 0xe1:	/* ,u++ */
		    post.b.a=memory[(U+=2)-2];
		    break;
		  case 0xe2:	/* ,-u */
		    post.b.a=memory[--U];
		    break;
		  case 0xe3:	/* ,--u */
		    post.b.a=memory[U-=2];
		    break;
		  case 0xe4:	/* ,u */
		    post.b.a=memory[U];
		    break;
		  case 0xe5:	/* b,u */
		    post.b.a=memory[U+(char) B];
		    break;
		  case 0xe6:	/* a,u */
		    post.b.a=memory[U+(char) A];
		    break;
		  case 0xe8:	/* $XX,u */
		    post.b.a=memory[U+(char) memory[PC++]];
		    break;
		  case 0xe9:	/* $XXXX,u */
		    post.b.a=memory[U+wfetch((PC+=2)-2)];
		    break;
		  case 0xeb:	/* d,u */
		    post.b.a=memory[U+D];
		    break;
		  case 0xf1:	/* [,u++] */
		    post.b.a=memory[wfetch((U+=2)-2)];
		    break;
		  case 0xf3:	/* [,--u] */
		    post.b.a=memory[wfetch(U-=2)];
		    break;
		  case 0xf4:	/* [,u] */
		    post.b.a=memory[wfetch(U)];
		    break;
		  case 0xf5:	/* [b.u] */
		    post.b.a=memory[wfetch(U+(char) B)];
		    break;
		  case 0xf6:	/* [a,u] */
		    post.b.a=memory[wfetch(U+(char) A)];
		    break;
		  case 0xf8:	/* [$XX,u] */
		    post.b.a=memory[wfetch(U+(char) memory[PC++])];
		    break;
		  case 0xf9:	/* [$XXXX,u] */
		    post.b.a=memory[wfetch(U+wfetch((PC+=2)-2))];
		    break;
		  case 0xfb:	/* d,u */
		    post.b.a=memory[wfetch(U+D)];
		    break;
		  default:	/* unimplemented mode */
		    unimp("Illegal Indexed Addressing Mode");
		}
	    else /* !post.b.a&0x80 */ {
		post.w.e=post.b.a&0x1f;
		if (post.b.a&0x10) post.w.e |= 0xfff0;
		switch(post.b.a&0x60) {
		  case 0x00:	/* $XX,x (5-bit) */
		    post.b.a=memory[X+post.w.e];
		    break;
		  case 0x20:	/* $XX,y (5-bit) */
		    post.b.a=memory[Y+post.w.e];
		    break;
		  case 0x40:	/* $XX,s (5-bit) */
		    post.b.a=memory[S+post.w.e];
		    break;
		  case 0x60:	/* $XX,u (5-bit) */
		    post.b.a=memory[U+post.w.e];
		    break;
		}
	    }
	    break;
	  case INDW:	/* indirect (word) */
	    post.b.a=memory[PC++];
	    if (post.b.a&0x80)
		switch(post.b.a) {
		  case 0x80:	/* ,x+ */
		    post.w.a=wfetch(X++);
		    break;
		  case 0x81:	/* ,x++ */
		    post.w.a=wfetch((X+=2)-2);
		    break;
		  case 0x82:	/* ,-x */
		    post.w.a=wfetch(--X);
		    break;
		  case 0x83:	/* ,--x */
		    post.w.a=wfetch(X-=2);
		    break;
		  case 0x84:	/* x */
		    post.w.a=wfetch(X);
		    break;
		  case 0x85:	/* b,x */
		    post.w.a=wfetch(X+(char) B);
		    break;
		  case 0x86:	/* a,x */
		    post.w.a=wfetch(X+(char) A);
		    break;
		  case 0x88:	/* $XX,x */
		    post.w.a=wfetch(X+(char) memory[PC++]);
		    break;
		  case 0x89:	/* $XXXX,x */
		    post.w.a=wfetch(X+wfetch((PC+=2)-2));
		    break;
		  case 0x8b:	/* d,x */
		    post.w.a=wfetch(X+D);
		    break;
		  case 0x8c: case 0xac: case 0xcc: case 0xec:	/* $xx,pc */
		    post.b.a=memory[PC++];
		    post.w.a=wfetch(PC+(char) post.b.a);
		    break;
		  case 0x8d: case 0xad: case 0xcd: case 0xed:	/* $XXXX,pc */
		    post.w.a=wfetch((PC+=2)-2);
		    post.w.a=wfetch(PC+post.w.a);
		    break;
		  case 0x91:	/* [,x++] */
		    post.w.a=wfetch(wfetch((X+=2)-2));
		    break;
		  case 0x93:	/* [,--x] */
		    post.w.a=wfetch(wfetch(X-=2));
		    break;
		  case 0x94:	/* [,x] */
		    post.w.a=wfetch(wfetch(X));
		    break;
		  case 0x95:	/* [b,x] */
		    post.w.a=wfetch(wfetch(X+(char) B));
		    break;
		  case 0x96:	/* [a,x] */
		    post.w.a=wfetch(wfetch(X+(char) A));
		    break;
		  case 0x98:	/* [$XX,x] */
		    post.w.a=wfetch(wfetch(X+(char) memory[PC++]));
		    break;
		  case 0x99:	/* [$XXXX,x] */
		    post.w.a=wfetch(wfetch(X+wfetch((PC+=2)-2)));
		    break;
		  case 0x9b:	/* [d,x] */
		    post.w.a=wfetch(wfetch(X+D));
		    break;
		  case 0x9c: case 0xbc: case 0xdc: case 0xfc:	/* [$XX,pc] */
		    post.b.a=memory[PC++];
		    post.w.a=wfetch(wfetch(PC+(char) post.b.a));
		    break;
		  case 0x9d: case 0xbd: case 0xdd: case 0xfd:	/* [$XXXX,pc] */
		    post.w.a=wfetch((PC+=2)-2);
		    post.w.a=wfetch(wfetch(PC+post.w.a));
		    break;
		  case 0x9f: case 0xbf: case 0xdf: case 0xff:	/* [$XXXX] */
		    post.w.a=wfetch(wfetch(wfetch((PC+=2)-2)));
		    break;
		  case 0xa0:	/* ,y+ */
		    post.w.a=wfetch(Y++);
		    break;
		  case 0xa1:	/* ,y++ */
		    post.w.a=wfetch((Y+=2)-2);
		    break;
		  case 0xa2:	/* ,-y */
		    post.w.a=wfetch(--Y);
		    break;
		  case 0xa3:	/* ,--y */
		    post.w.a=wfetch(Y-=2);
		    break;
		  case 0xa4:	/* ,y */
		    post.w.a=wfetch(Y);
		    break;
		  case 0xa5:	/* b,y */
		    post.w.a=wfetch(Y+(char) B);
		    break;
		  case 0xa6:	/* a,y */
		    post.w.a=wfetch(Y+(char) A);
		    break;
		  case 0xa8:	/* $XX,y */
		    post.w.a=wfetch(Y+(char) memory[PC++]);
		    break;
		  case 0xa9:	/* $XXXX,y */
		    post.w.a=wfetch(Y+wfetch((PC+=2)-2));
		    break;
		  case 0xab:	/* d,y */
		    post.w.a=wfetch(Y+D);
		    break;
		  case 0xb1:	/* [,y++] */
		    post.w.a=wfetch(wfetch((Y+=2)-2));
		    break;
		  case 0xb3:	/* [,--y] */
		    post.w.a=wfetch(wfetch(Y-=2));
		    break;
		  case 0xb4:	/* [,y] */
		    post.w.a=wfetch(wfetch(Y));
		    break;
		  case 0xb5:	/* [b,y] */
		    post.w.a=wfetch(wfetch(Y+(char) B));
		    break;
		  case 0xb6:	/* [a,y] */
		    post.w.a=wfetch(wfetch(Y+(char) A));
		    break;
		  case 0xb8:	/* [$XX,y] */
		    post.w.a=wfetch(wfetch(Y+(char) memory[PC++]));
		    break;
		  case 0xb9:	/* [$XXXX,y] */
		    post.w.a=wfetch(wfetch(Y+wfetch((PC+=2)-2)));
		    break;
		  case 0xbb:	/* [d,y] */
		    post.w.a=wfetch(wfetch(Y+D));
		    break;
		  case 0xc0:	/* ,s+ */
		    post.w.a=wfetch(S++);
		    break;
		  case 0xc1:	/* ,s++ */
		    post.w.a=wfetch((S+=2)-2);
		    break;
		  case 0xc2:	/* ,-s */
		    post.w.a=wfetch(--S);
		    break;
		  case 0xc3:	/* ,--s */
		    post.w.a=wfetch(S-=2);
		    break;
		  case 0xc4:	/* ,s */
		    post.w.a=wfetch(S);
		    break;
		  case 0xc5:	/* b,s */
		    post.w.a=wfetch(S+(char) B);
		    break;
		  case 0xc6:	/* a,s */
		    post.w.a=wfetch(S+(char) A);
		    break;
		  case 0xc8:	/* $XX,s */
		    post.w.a=wfetch(S+(char) memory[PC++]);
		    break;
		  case 0xc9:	/* $XXXX,s */
		    post.w.a=wfetch(S+wfetch((PC+=2)-2));
		    break;
		  case 0xcb:	/* d,s */
		    post.w.a=wfetch(S+D);
		    break;
		  case 0xd1:	/* [,s++] */
		    post.w.a=wfetch(wfetch((S+=2)-2));
		    break;
		  case 0xd3:	/* [,--s] */
		    post.w.a=wfetch(wfetch(S-=2));
		    break;
		  case 0xd4:	/* [,s] */
		    post.w.a=wfetch(wfetch(S));
		    break;
		  case 0xd5:	/* [b,s] */
		    post.w.a=wfetch(wfetch(S+(char) B));
		    break;
		  case 0xd6:	/* [a,s] */
		    post.w.a=wfetch(wfetch(S+(char) A));
		    break;
		  case 0xd8:	/* [$XX,s] */
		    post.w.a=wfetch(wfetch(S+(char) memory[PC++]));
		    break;
		  case 0xd9:	/* [$XXXX,s] */
		    post.w.a=wfetch(wfetch(S+wfetch((PC+=2)-2)));
		    break;
		  case 0xdb:	/* [d,s] */
		    post.w.a=wfetch(wfetch(S+D));
		    break;
		  case 0xe0:	/* ,u+ */
		    post.w.a=wfetch(U++);
		    break;
		  case 0xe1:	/* ,u++ */
		    post.w.a=wfetch((U+=2)-2);
		    break;
		  case 0xe2:	/* ,-u */
		    post.w.a=wfetch(--U);
		    break;
		  case 0xe3:	/* ,--u */
		    post.w.a=wfetch(U-=2);
		    break;
		  case 0xe4:	/* ,u */
		    post.w.a=wfetch(U);
		    break;
		  case 0xe5:	/* b,u */
		    post.w.a=wfetch(U+(char) B);
		    break;
		  case 0xe6:	/* a,u */
		    post.w.a=wfetch(U+(char) A);
		    break;
		  case 0xe8:	/* $XX,u */
		    post.w.a=wfetch(U+(char) memory[PC++]);
		    break;
		  case 0xe9:	/* $XXXX,u */
		    post.w.a=wfetch(U+wfetch((PC+=2)-2));
		    break;
		  case 0xeb:	/* d,u */
		    post.w.a=wfetch(U+D);
		    break;
		  case 0xf1:	/* [,u++] */
		    post.w.a=wfetch(wfetch((U+=2)-2));
		    break;
		  case 0xf3:	/* [,--u] */
		    post.w.a=wfetch(wfetch(U-=2));
		    break;
		  case 0xf4:	/* [,u] */
		    post.w.a=wfetch(wfetch(U));
		    break;
		  case 0xf5:	/* [b,u] */
		    post.w.a=wfetch(wfetch(U+(char) B));
		    break;
		  case 0xf6:	/* [a,u] */
		    post.w.a=wfetch(wfetch(U+(char) A));
		    break;
		  case 0xf8:	/* [$XX,u] */
		    post.w.a=wfetch(wfetch(U+(char) memory[PC++]));
		    break;
		  case 0xf9:	/* [$XXXX,u] */
		    post.w.a=wfetch(wfetch(U+wfetch((PC+=2)-2)));
		    break;
		  case 0xfb:	/* [d,u] */
		    post.w.a=wfetch(wfetch(U+D));
		    break;
		  default:	/* unimplemented mode */
		    unimp("Illegal Indexed Addressing Mode");
		}
	    else /* !post.b.a&0x80 */ {
		post.w.e=post.b.a&0x1f;
		if (post.b.a&0x10) post.w.e |= 0xfff0;
		switch(post.b.a&0x60) {
		  case 0x00:	/* $XX,x (5-bit) */
		    post.w.a=wfetch(X+post.w.e);
		    break;
		  case 0x20:	/* $XX,y (5-bit) */
		    post.w.a=wfetch(Y+post.w.e);
		    break;
		  case 0x40:	/* $XX,s (5-bit) */
		    post.w.a=wfetch(S+post.w.e);
		    break;
		  case 0x60:	/* $XX,u (5-bit) */
		    post.w.a=wfetch(U+post.w.e);
		    break;
		}
	    }
	    break;
	  case INDL:
	    post.b.a=memory[PC++];
	    if (post.b.a&0x80)
		switch(post.b.a) {
		  case 0x80:	/* ,x+ */
		    post.l.a=lfetch(X++);
		    break;
		  case 0x81:	/* ,x++ */
		    post.l.a=lfetch((X+=2)-2);
		    break;
		  case 0x82:	/* ,-x */
		    post.l.a=lfetch(--X);
		    break;
		  case 0x83:	/* ,--x */
		    post.l.a=lfetch(X-=2);
		    break;
		  case 0x84:	/* ,x */
		    post.l.a=lfetch(X);
		    break;
		  case 0x85:	/* b.x */
		    post.l.a=lfetch(X+(char) B);
		    break;
		  case 0x86:	/* a,x */
		    post.l.a=lfetch(X+(char) A);
		    break;
		  case 0x88:	/* $XX,x */
		    post.l.a=lfetch(X+(char) memory[PC++]);
		    break;
		  case 0x89:	/* $XXXX,x */
		    post.l.a=lfetch(X+wfetch((PC+=2)-2));
		    break;
		  case 0x8b:	/* d,x */
		    post.l.a=lfetch(X+D);
		    break;
		  case 0x8c: case 0xac: case 0xcc: case 0xec:	/* $XX,pc */
		    post.b.a=memory[PC++];
		    post.l.a=lfetch(PC+(char) post.b.a);
		    break;
		  case 0x8d: case 0xad: case 0xcd: case 0xed:	/* $XXXX,pc */
		    post.w.a=wfetch((PC+=2)-2);
		    post.l.a=lfetch(PC+post.w.a);
		    break;
		  case 0x91:	/* [,x++] */
		    post.l.a=lfetch(wfetch((X+=2)-2));
		    break;
		  case 0x93:	/* [,--x] */
		    post.l.a=lfetch(wfetch(X-=2));
		    break;
		  case 0x94:	/* [,x] */
		    post.l.a=lfetch(wfetch(X));
		    break;
		  case 0x95:	/* [b,x] */
		    post.l.a=lfetch(wfetch(X+(char) B));
		    break;
		  case 0x96:	/* [a,x] */
		    post.l.a=lfetch(wfetch(X+(char) A));
		    break;
		  case 0x98:	/* [$XX,x] */
		    post.l.a=lfetch(wfetch(X+(char) memory[PC++]));
		    break;
		  case 0x99:	/* [$XXXX,x] */
		    post.l.a=lfetch(wfetch(X+wfetch((PC+=2)-2)));
		    break;
		  case 0x9b:	/* [d,x] */
		    post.l.a=lfetch(wfetch(X+D));
		    break;
		  case 0x9c: case 0xbc: case 0xdc: case 0xfc:	/* [$XX,pc] */
		    post.b.a=memory[PC++];
		    post.l.a=lfetch(wfetch(PC+(char) post.b.a));
		    break;
		  case 0x9d: case 0xbd: case 0xdd: case 0xfd:	/* [$XXXX,pc] */
		    post.w.a=wfetch((PC+=2)-2);
		    post.l.a=lfetch(wfetch(PC+post.w.a));
		    break;
		  case 0x9f: case 0xbf: case 0xdf: case 0xff:	/* [$XXXX] */
		    post.l.a=lfetch(wfetch(wfetch((PC+=2)-2)));
		    break;
		  case 0xa0:	/* ,y+ */
		    post.l.a=lfetch(Y++);
		    break;
		  case 0xa1:	/* ,y++ */
		    post.l.a=lfetch((Y+=2)-2);
		    break;
		  case 0xa2:	/* ,-y */
		    post.l.a=lfetch(--Y);
		    break;
		  case 0xa3:	/* ,--y */
		    post.l.a=lfetch(Y-=2);
		    break;
		  case 0xa4:	/* ,y */
		    post.l.a=lfetch(Y);
		    break;
		  case 0xa5:	/* b,y */
		    post.l.a=lfetch(Y+(char) B);
		    break;
		  case 0xa6:	/* a,y */
		    post.l.a=lfetch(Y+(char) A);
		    break;
		  case 0xa8:	/* $XX,y */
		    post.l.a=lfetch(Y+(char) memory[PC++]);
		    break;
		  case 0xa9:	/* $XXXX,y */
		    post.l.a=lfetch(Y+wfetch((PC+=2)-2));
		    break;
		  case 0xab:	/* d,y */
		    post.l.a=lfetch(Y+D);
		    break;
		  case 0xb1:	/* [,y++] */
		    post.l.a=lfetch(wfetch((Y+=2)-2));
		    break;
		  case 0xb3:	/* [,--y] */
		    post.l.a=lfetch(wfetch(Y-=2));
		    break;
		  case 0xb4:	/* [,y] */
		    post.l.a=lfetch(wfetch(Y));
		    break;
		  case 0xb5:	/* [b,y] */
		    post.l.a=lfetch(wfetch(Y+(char) B));
		    break;
		  case 0xb6:	/* [a,y] */
		    post.l.a=lfetch(wfetch(Y+(char) A));
		    break;
		  case 0xb8:	/* [$XX,y] */
		    post.l.a=lfetch(wfetch(Y+(char) memory[PC++]));
		    break;
		  case 0xb9:	/* [$XXXX,y] */
		    post.l.a=lfetch(wfetch(Y+wfetch((PC+=2)-2)));
		    break;
		  case 0xbb:	/* [d,y] */
		    post.l.a=lfetch(wfetch(Y+D));
		    break;
		  case 0xc0:	/* ,s+ */
		    post.l.a=lfetch(S++);
		    break;
		  case 0xc1:	/* ,s++ */
		    post.l.a=lfetch((S+=2)-2);
		    break;
		  case 0xc2:	/* ,-s */
		    post.l.a=lfetch(--S);
		    break;
		  case 0xc3:	/* ,--s */
		    post.l.a=lfetch(S-=2);
		    break;
		  case 0xc4:	/* ,s */
		    post.l.a=lfetch(S);
		    break;
		  case 0xc5:	/* b,s */
		    post.l.a=lfetch(S+(char) B);
		    break;
		  case 0xc6:	/* a,s */
		    post.l.a=lfetch(S+(char) A);
		    break;
		  case 0xc8:	/* $XX,s */
		    post.l.a=lfetch(S+(char) memory[PC++]);
		    break;
		  case 0xc9:	/* $XXXX,s */
		    post.l.a=lfetch(S+wfetch((PC+=2)-2));
		    break;
		  case 0xcb:	/* d,s */
		    post.l.a=lfetch(S+D);
		    break;
		  case 0xd1:	/* [,s++] */
		    post.l.a=lfetch(wfetch((S+=2)-2));
		    break;
		  case 0xd3:	/* [,--s] */
		    post.l.a=lfetch(wfetch(S-=2));
		    break;
		  case 0xd4:	/* [,s] */
		    post.l.a=lfetch(wfetch(S));
		    break;
		  case 0xd5:	/* [b,s] */
		    post.l.a=lfetch(wfetch(S+(char) B));
		    break;
		  case 0xd6:	/* [a,s] */
		    post.l.a=lfetch(wfetch(S+(char) A));
		    break;
		  case 0xd8:	/* [$XX,s] */
		    post.l.a=lfetch(wfetch(S+(char) memory[PC++]));
		    break;
		  case 0xd9:	/* [$XXXX,s] */
		    post.l.a=lfetch(wfetch(S+wfetch((PC+=2)-2)));
		    break;
		  case 0xdb:	/* [d,s] */
		    post.l.a=lfetch(wfetch(S+D));
		    break;
		  case 0xe0:	/* ,u+ */
		    post.l.a=lfetch(U++);
		    break;
		  case 0xe1:	/* ,u++ */
		    post.l.a=lfetch((U+=2)-2);
		    break;
		  case 0xe2:	/* ,-u */
		    post.l.a=lfetch(--U);
		    break;
		  case 0xe3:	/* ,--u */
		    post.l.a=lfetch(U-=2);
		    break;
		  case 0xe4:	/* ,u */
		    post.l.a=lfetch(U);
		    break;
		  case 0xe5:	/* b,u */
		    post.l.a=lfetch(U+(char) B);
		    break;
		  case 0xe6:	/* a,u */
		    post.l.a=lfetch(U+(char) A);
		    break;
		  case 0xe8:	/* $XX,u */
		    post.l.a=lfetch(U+(char) memory[PC++]);
		    break;
		  case 0xe9:	/* $XXXX,u */
		    post.l.a=lfetch(U+wfetch((PC+=2)-2));
		    break;
		  case 0xeb:	/* d,u */
		    post.l.a=lfetch(U+D);
		    break;
		  case 0xf1:	/* [,u++] */
		    post.l.a=lfetch(wfetch((U+=2)-2));
		    break;
		  case 0xf3:	/* [,--u] */
		    post.l.a=lfetch(wfetch(U-=2));
		    break;
		  case 0xf4:	/* [,u] */
		    post.l.a=lfetch(wfetch(U));
		    break;
		  case 0xf5:	/* [b,u] */
		    post.l.a=lfetch(wfetch(U+(char) B));
		    break;
		  case 0xf6:	/* [a,u] */
		    post.l.a=lfetch(wfetch(U+(char) A));
		    break;
		  case 0xf8:	/* [$XX,u] */
		    post.l.a=lfetch(wfetch(U+(char) memory[PC++]));
		    break;
		  case 0xf9:	/* [$XXXX,u] */
		    post.l.a=lfetch(wfetch(U+wfetch((PC+=2)-2)));
		    break;
		  case 0xfb:	/* [d,u] */
		    post.l.a=lfetch(wfetch(U+D));
		    break;
		  default:	/* unimplemented mode */
		    unimp("Illegal Indexed Addressing Mode");
		}
	    else /* !post.b.a&0x80 */ {
		post.w.e=post.b.a&0x1f;
		if (post.b.a&0x10) post.w.e |= 0xfff0;
		switch(post.b.a&0x60) {
		  case 0x00:	/* $XX,x (5-bit) */
		    post.l.a=lfetch(X+post.w.e);
		    break;
		  case 0x20:	/* $XX,y (5-bit) */
		    post.l.a=lfetch(Y+post.w.e);
		    break;
		  case 0x4:	/* $XX,s (5-bit) */
		    post.l.a=lfetch(S+post.w.e);
		    break;
		  case 0x60:	/* $XX,u (5-bit) */
		    post.l.a=lfetch(U+post.w.e);
		    break;
		}
	    }
	    break;
	  case RELB:	/* relatve branch (short) */
	    post.b.a=memory[PC++];
	    post.w.a=PC+(char)post.b.a;
	    break;
	  case RELW:	/* relative branch (long) */
	    post.w.a=wfetch((PC+=2)-2);
	    post.w.a=PC+(short)post.w.a;
	    break;
	  case REGS:	/* register mode */
	    post.b.a=memory[PC++];
	  case INH0:	/* inherent (no post-bytes) */
	  case UNIM:	/* unimplemented instruction */
	  case PRE1:	/* prebyte-1 ($10) */
	  case PRE2:	/* prebyte-2 ($11) */
	    break;
	}

	switch(i0) {
	  case 0x00: case 0x60: case 0x70:	/* neg */	/* neg.b (a0) */
	    mub = -memory[post.w.a];
	    CC.bit.v = (mub==0x80);
	    CC.bit.z = CC.bit.c = !mub;
	    CC.bit.n = btst(mub, 7);
	    memory[post.w.a] = mub;
	    break;	/* neg.b (a0) */
	  case 0x01: case 0x61: case 0x71:	/* oim  */
	    unimp("oim");
	    break;
	  case 0x02: case 0x62: case 0x72:	/* aim */
	    unimp("aim");
	    break;
	  case 0x03: case 0x63: case 0x73:	/* com */	/* neg.b (a0)	subq.b #1, (a0) */
	    mub = ~memory[post.w.a];
	    CC.bit.c=1;
	    CC.bit.v=0;
	    CC.bit.n=btst(mub, 7);
	    CC.bit.z=!mub;
	    memory[post.w.a]=mub;
	    break;
	  case 0x04: case 0x64: case 0x74:	/* lsr */	/* lsl.b #1, (a0) */
	    mub=memory[post.w.a];
	    CC.bit.c = btst(mub, 0);
	    mub >>= 1;
	    CC.bit.n = 0;
	    CC.bit.z = !mub;
	    memory[post.w.a] = mub;
	    break;
	  case 0x05: case 0x65: case 0x75:	/* eim */
	    unimp("eim");
	    break;
	  case 0x06: case 0x66: case 0x76:	/* ror */	/* ror.b #1, (a0) */
	    mub=memory[post.w.a];
	    muw = CC.bit.c;
	    CC.bit.c = btst(mub, 0);
	    mub >>= 1;
	    if (muw) bset(mub, 7);
	    CC.bit.n = btst(mub, 7);
	    CC.bit.z = !mub;
	    memory[post.w.a]=mub;
	    break;
	  case 0x07: case 0x67: case 0x77:	/* asr */	/* asr.b #1, (a0) */
	    msb=memory[post.w.a];
	    CC.bit.c = btst(msb, 0);
	    msb >>= 1;
	    CC.bit.z = !msb;
	    memory[post.w.a] = msb;
	    break;
	  case 0x08: case 0x68: case 0x78:	/* asl, lsl */	/* asl.b #1, (a0) */
	    mub=memory[post.w.a];
	    CC.bit.c = btst(mub, 7);
	    CC.bit.v = btst(mub, 7) ^ btst(mub, 6);
	    mub <<= 1;
	    CC.bit.n = btst(mub, 7);
	    CC.bit.z = !mub;
	    memory[post.w.a]=mub;
	    break;
	  case 0x09: case 0x69: case 0x79:	/* rol */	/* rol.b #1, (a0) */
	    mub=memory[post.w.a];
	    muw = CC.bit.c;
	    CC.bit.v = btst(mub, 7) ^ btst(mub, 6);
	    CC.bit.c = btst(mub, 7);
	    mub <<= 1;
	    if (muw) bset(mub, 0);
	    CC.bit.n = btst(mub, 7);
	    CC.bit.z = !mub;
	    memory[post.w.a]=mub;
	    break;
	  case 0x0a: case 0x6a: case 0x7a:	/* dec */	/* subq.b #1, (a0) */
	    mub=memory[post.w.a];
	    CC.bit.v = (mub--==0x80);
	    CC.bit.n = btst(mub, 7);
	    CC.bit.z = !mub;
	    memory[post.w.a]=mub;
	    break;
	  case 0x0b: case 0x6b: case 0x7b:	/* tim */
	    unimp("tim");
	    break;
	  case 0x0c: case 0x6c: case 0x7c:	/* inc */	/* addq.b #1, (a0) */
	    mub=memory[post.w.a];
	    CC.bit.v = (mub++==0x7f);
	    CC.bit.n = btst(mub, 7);
	    CC.bit.z = !mub;
	    memory[post.w.a]=mub;
	    break;
	  case 0x0d: case 0x6d: case 0x7d:	/* tst */	/* tst.b #1, (a0) */
	    mub=memory[post.w.a];
	    CC.bit.v = 0;
	    CC.bit.n = btst(mub, 7);
	    CC.bit.z = !mub;
	    break;
	  case 0x0e: case 0x6e: case 0x7e:	/* jmp */	/* move.b a0, a1 */ 
	    PC = post.w.a;
	    break;
	  case 0x0f: case 0x6f: case 0x7f:	/* clr */	/* clr.b (a0) */
	    memory[post.w.a] = 0;
	    CC.all &= 0xf4;
	    CC.all |= 0x04;
	    break;
	  case 0x12:
	    		/* nop */
	    break;
	  case 0x13:	/* sync */
	    state();	/* unimp("sync"); */
	    break;
	  case 0x14:	/* sexw */
	    CC.bit.n = btst(F, 7);
	    CC.bit.z = !F;
	    E = CC.bit.n ? 0xff : 0;
	    break;
	  case 0x16:	/* lbra */
	    PC=post.w.a;
	    break;
	  case 0x17:	/* lbsr */
	    wstore(S-=2, PC);
	    PC=post.w.a;
	    break;
	  case 0x19:	/* daa */
	    lsn = A&0x0f;
	    msn = A&0xf0;
	    if(CC.bit.h || lsn>9)
		mub=0x06;
	    else
		mub=0x00;
	    if(CC.bit.c || msn>0x90 || (msn>0x80 && lsn>9)) mub|=0x60;
	    muw = A + mub;
	    CC.bit.c = btst(muw, 8);
	    A = muw;
	    break;
	  case 0x1a:	/* orcc */
	    CC.all|=post.b.a;
	    break;
	  case 0x1c:	/* andcc */
	    CC.all&=post.b.a;
	    break;
	  case 0x1d:	/* sex */
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    A = CC.bit.n ? 0xff : 0;
	    break;
	  case 0x1e:	/* exg */
	    if(rlen[post.n.a] != rlen[post.n.b] || !rlen[post.n.a]) unimp("illegal mode");
	    switch(post.n.a) {
	      case 0x00:
		msl=D;
		break;
	      case 0x01:
		msl=X;
		break;
	      case 0x02:
		msl=Y;
		break;
	      case 0x03:
		msl=S;
		break;
	      case 0x04:
		msl=U;
		break;
	      case 0x05:
		msl=PC;
		break;
	      case 0x06:
		msl=W;
		break;
	      case 0x07:
		msl=V;
		break;
	      case 0x08:
		msl=A;
		break;
	      case 0x09:
		msl=B;
		break;
	      case 0x0a:
		msl=CC.all;
		break;
	      case 0x0b:
		msl=DP;
		break;
/*	      case 0x0c:
		msl=;
		break;
	      case 0x0d:
		msl=;
		break;	*/
	      case 0x0e:
		msl=E;
		break;
	      case 0x0f:
		msl=F;
		break;
	      default:
		unimp("Illegal Register Mode");
	    }
	    switch(post.n.b) {
	      case 0x00:
		mul=D;
		D=msl;
		break;
	      case 0x01:
		mul=X;
		X=msl;
		break;
	      case 0x02:
		mul=Y;
		Y=msl;
		break;
	      case 0x03:
		mul=S;
		S=msl;
		break;
	      case 0x04:
		mul=U;
		U=msl;
		break;
	      case 0x05:
		mul=PC;
		PC=msl;
		break;
	      case 0x06:
		mul=W;
		W=msl;
		break;
	      case 0x07:
		mul=V;
		V=msl;
		break;
	      case 0x08:
		mul=A;
		A=msl;
		break;
	      case 0x09:
		mul=B;
		B=msl;
		break;
	      case 0x0a:
		mul=CC.all;
		CC.all=msl;
		break;
	      case 0x0b:
		mul=DP;
		DP=msl;
		break;
/*	      case 0x0c:
		mul=;
		=msl;
		break;
	      case 0x0d:
		mul=;
		=msl;
		break;	*/
	      case 0x0e:
		mul=E;
		E=msl;
		break;
	      case 0x0f:
		mul=F;
		F=msl;
		break;
	      default:
		unimp("Illegal Register Mode");
	    }
	    switch(post.n.a) {
	      case 0x00:
		D=mul;
		break;
	      case 0x01:
		X=mul;
		break;
	      case 0x02:
		Y=mul;
		break;
	      case 0x03:
		S=mul;
		break;
	      case 0x04:
		U=mul;
		break;
	      case 0x05:
		PC=mul;
		break;
	      case 0x06:
		W=mul;
		break;
	      case 0x07:
		V=mul;
		break;
	      case 0x08:
		A=mul;
		break;
	      case 0x09:
		B=mul;
		break;
	      case 0x0a:
		CC.all=mul;
		break;
	      case 0x0b:
		DP=mul;
		break;
/*	      case 0x0c:
		=mul;
		break;
	      case 0x0d:
		=mul;
		break;	*/
	      case 0x0e:
		E=mul;
		break;
	      case 0x0f:
		F=mul;
		break;
	      default:
		unimp("Illegal Register Mode");
	    }
	    break;
	  case 0x1f:	/* tfr */
	    mub=memory[PC++];
	    post.n.a=(mub&0xf0)>>4;
	    post.n.b=mub&0x0f;
	    if(rlen[post.n.a] != rlen[post.n.b] || !post.n.a) unimp();
	    switch(post.n.a) {
	      case 0x00:
		msl=D;
		break;
	      case 0x01:
		msl=X;
		break;
	      case 0x02:
		msl=Y;
		break;
	      case 0x03:
		msl=S;
		break;
	      case 0x04:
		msl=U;
		break;
	      case 0x05:
		msl=PC;
		break;
	      case 0x06:
		msl=W;
		break;
	      case 0x07:
		msl=V;
		break;
	      case 0x08:
		msl=A;
		break;
	      case 0x09:
		msl=B;
		break;
	      case 0x0a:
		msl=CC.all;
		break;
	      case 0x0b:
		msl=DP;
		break;
/*	      case 0x0c:
		msl=;
		break;
	      case 0x0d:
		msl=;
		break;	*/
	      case 0x0e:
		msl=E;
		break;
	      case 0x0f:
		msl=F;
		break;
	      default:
		unimp("Illegal Register Mode");
	    }
	    switch(post.n.b) {
	      case 0x00:
		D=msl;
		break;
	      case 0x01:
		X=msl;
		break;
	      case 0x02:
		Y=msl;
		break;
	      case 0x03:
		S=msl;
		break;
	      case 0x04:
		U=msl;
		break;
	      case 0x05:
		PC=msl;
		break;
	      case 0x06:
		W=msl;
		break;
	      case 0x07:
		V=msl;
		break;
	      case 0x08:
		A=msl;
		break;
	      case 0x09:
		B=msl;
		break;
	      case 0x0a:
		CC.all=msl;
		break;
	      case 0x0b:
		DP=msl;
		break;
/*	      case 0x0c:
		=msl;
		break;
	      case 0x0d:
		=msl;
		break;	*/
	      case 0x0e:
		E=msl;
		break;
	      case 0x0f:
		F=msl;
		break;
	      default:
		unimp("Illegal Register Mode");
	    }
	    break;
	  case 0x20:	/* bra */
	    PC=post.w.a;
	    break;
	  case 0x21:	/* brn */
	    break;
	  case 0x22:	/* bhi */
	    if (!(CC.bit.c | CC.bit.z)) PC=post.w.a;
	    break;
	  case 0x23:	/* bls */
	    if (CC.bit.c | CC.bit.z) PC=post.w.a;
	    break;
	  case 0x24:	/* bcc */
	    if (!CC.bit.c) PC=post.w.a;
	    break;
	  case 0x25:
	    if (CC.bit.c) PC=post.w.a;
	    break;
	  case 0x26:	/* bne */
	    if (!CC.bit.z) PC=post.w.a;
	    break;
	  case 0x27:	/* beq */
	    if (CC.bit.z) PC=post.w.a;
	    break;
	  case 0x28:	/* bvc */
	    if (!CC.bit.v) PC=post.w.a;
	    break;
	  case 0x29:	/* bvs */
	    if (CC.bit.v) PC=post.w.a;
	    break;
	  case 0x2a:	/* bpl */
	    if (!CC.bit.n) PC=post.w.a;
	    break;
	  case 0x2b:	/* bmi */
	    if (CC.bit.n) PC=post.w.a;
	    break;
	  case 0x2c:	/* bge */
	    if (!(CC.bit.n ^ CC.bit.v)) PC=post.w.a;
	    break;
	  case 0x2d:	/* blt */
	    if (CC.bit.n ^ CC.bit.v) PC=post.w.a;
	    break;
	  case 0x2e:	/* bgt */
	    if (!(CC.bit.z & (CC.bit.n ^ CC.bit.v))) PC=post.w.a;
	    break;
	  case 0x2f:
	    if (CC.bit.z & (CC.bit.n ^ CC.bit.v)) PC=post.w.a;
	    break;
	  case 0x30:	/* leax */
	    X=post.w.a;
	    CC.bit.z=!X;
	    break;
	  case 0x31:	/* leay */
	    Y=post.w.a;
	    CC.bit.z=!Y;
	    break;
	  case 0x32:	/* leas */
	    S=post.w.a;
	    CC.bit.z=!S;
	    break;
	  case 0x33:	/* leau */
	    U=post.w.a;
	    CC.bit.z=!U;
	    break;
	  case 0x34:	/* pshs */
	    if (btst(post.b.a, 7)) wstore(S-=2, PC);
	    if (btst(post.b.a, 6)) wstore(S-=2, U);
	    if (btst(post.b.a, 5)) wstore(S-=2, Y);
	    if (btst(post.b.a, 4)) wstore(S-=2, X);
	    if (btst(post.b.a, 3)) memory[--S]=DP;
	    if (btst(post.b.a, 2)) memory[--S]=B;
	    if (btst(post.b.a, 1)) memory[--S]=A;
	    if (btst(post.b.a, 0)) memory[--S]=CC.all;
	    break;
	  case 0x35:	/* puls */
	    if (btst(post.b.a, 0)) CC.all=memory[S++];
	    if (btst(post.b.a, 1)) A=memory[S++];
	    if (btst(post.b.a, 2)) B=memory[S++];
	    if (btst(post.b.a, 3)) DP=memory[S++];
	    if (btst(post.b.a, 4)) X=wfetch((S+=2)-2);
	    if (btst(post.b.a, 5)) Y=wfetch((S+=2)-2);
	    if (btst(post.b.a, 6)) U=wfetch((S+=2)-2);
	    if (btst(post.b.a, 7)) PC=wfetch((S+=2)-2);
	    break;
	  case 0x36:	/* pshu */
	    if (btst(post.b.a, 7)) wstore(U-=2, PC);
	    if (btst(post.b.a, 6)) wstore(U-=2, S);
	    if (btst(post.b.a, 5)) wstore(U-=2, Y);
	    if (btst(post.b.a, 4)) wstore(U-=2, X);
	    if (btst(post.b.a, 3)) memory[--U]=DP;
	    if (btst(post.b.a, 2)) memory[--U]=B;
	    if (btst(post.b.a, 1)) memory[--U]=A;
	    if (btst(post.b.a, 0)) memory[--U]=CC.all;
	    break;
	  case 0x37:	/* pulu */
	    if (btst(post.b.a, 0)) CC.all=memory[U++];
	    if (btst(post.b.a, 1)) A=memory[U++];
	    if (btst(post.b.a, 2)) B=memory[U++];
	    if (btst(post.b.a, 3)) DP=memory[U++];
	    if (btst(post.b.a, 4)) X=wfetch((U+=2)-2);
	    if (btst(post.b.a, 5)) Y=wfetch((U+=2)-2);
	    if (btst(post.b.a, 6)) S=wfetch((U+=2)-2);
	    if (btst(post.b.a, 7)) PC=wfetch((U+=2)-2);
	    break;
	  case 0x39:	/* rts */
	    PC=wfetch((S+=2)-2);
	    break;
	  case 0x3a:
	    X += B;	/* abx */
	    break;
	  case 0x3b:	/* rti */
	    if (CC.bit.e) {
		CC.all=memory[S++];
		A=memory[S++];
		B=memory[S++];
		DP=memory[S++];
		if (MD.bit.em) W=wfetch((S+=2)-2);
		X=wfetch((S+=2)-2);
		Y=wfetch((S+=2)-2);
		U=wfetch((S+=2)-2);
	    }
	    PC=wfetch((S+=2)-2);
	    break;
	  case 0x3c:	/* cwai, we want to intentionally misimplement this instruction for now */
	    return 0x3c;
	    break;
	  case 0x3d:	/* mul */
	    D = A*B;
	    CC.bit.c = btst(B, 7);	/* remember B is part of D, is this right? */
	    CC.bit.z = !D;
	    break;
	  case 0x3f:	/* swi */
	    CC.bit.e = 1;
	    wstore(S-=2, PC);
	    wstore(S-=2, U);
	    wstore(S-=2, Y);
	    wstore(S-=2, X);
	    memory[--S]=DP;
	    if (MD.bit.em) wstore(S-=2, W);
	    memory[--S]=B;
	    memory[--S]=A;
	    memory[--S]=CC.all;
	    CC.bit.f = CC.bit.i = 1;
	    PC = wfetch(0xfffa);
	    break;
	  case 0x40:	/* nega */
	    A=-A;
	    CC.bit.v = (A==0x80);
	    CC.bit.c = CC.bit.z = !A;
	    break;
	  case 0x43:	/* coma */
	    A=~A;
	    CC.bit.c=1;
	    CC.bit.v=0;
	    CC.bit.n=btst(A, 7);
	    CC.bit.z=!A;
	    break;
	  case 0x44:	/* lsra */
	    CC.bit.c = btst(A, 0);
	    A >>= 1;
	    CC.bit.n = 0;
	    CC.bit.z = !A;
	    break;
	  case 0x46:	/* rora */
	    muw = CC.bit.c;
	    CC.bit.c = btst(A, 0);
	    A >>= 1;
	    if (muw) bset(A, 7);
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x47:	/* asra */
	    CC.bit.c = btst(A, 0);
	    A >>= 1;
	    A |= (CC.bit.n=btst(A, 6))<<7;
	    CC.bit.z = !A;
	    break;
	  case 0x48:	/* asla, lsla */
	    CC.bit.c = btst(A, 7);
	    CC.bit.v = btst(A, 7) ^ btst(A, 6);
	    A <<= 1;
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x49:	/* rola */
	    muw = CC.bit.c;
	    CC.bit.v = btst(A, 7) ^ btst(A, 6);
	    CC.bit.c = btst(A, 7);
	    A <<= 1;
	    if (muw) bset(A, 0);
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x4a:	/* deca */
	    CC.bit.v = (A--==0x80);
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x4c:	/* inca */
	    CC.bit.v = (A++==0x7f);
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x4d:	/* tsta */
	    CC.bit.v = 0;
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x4f:	/* clra */
	    A=0;
	    CC.all &= 0xf4;
	    CC.all |= 0x04;
	    break;
	  case 0x50:	/* negb */
	    B=-B;
	    CC.bit.v = (B==0x80);
	    CC.bit.c = CC.bit.z = !B;
	    CC.bit.n = btst(B, 7);
	    break;
	  case 0x53:	/* comb */
	    B=~B;
	    CC.bit.c=1;
	    CC.bit.v=0;
	    CC.bit.n=btst(B, 7);
	    CC.bit.z=!B;
	    break;
	  case 0x54:	/* lsrb */
	    CC.bit.c = btst(B, 0);
	    B >>= 1;
	    CC.bit.n = 0;
	    CC.bit.z = !B;
	    break;
	  case 0x56:	/* rorb */
	    muw = CC.bit.c;
	    CC.bit.c = btst(B, 0);
	    B >>= 1;
	    if (muw) bset(B, 7);
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0x57:	/* asrb */
	    CC.bit.c = btst(B, 0);
	    B >>= 1;
	    B |= (CC.bit.n=btst(B, 6))<<7;
	    CC.bit.z = !B;
	    break;
	  case 0x58:	/* aslb, lslb */
	    CC.bit.c = btst(B, 7);
	    CC.bit.v = btst(B, 7) ^ btst(B, 6);
	    B <<= 1;
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0x59:	/* rolb */
	    muw = CC.bit.c;
	    CC.bit.v = btst(B, 7) ^ btst(B, 6);
	    CC.bit.c = btst(B, 7);
	    B <<= 1;
	    if (muw) bset(B, 0);
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0x5a:	/* decb */
	    CC.bit.v = (B--==0x80);
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0x5c:	/* incb */
	    CC.bit.v = (B++==0x7f);
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0x5d:	/* tstb */
	    CC.bit.v = 0;
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0x5f:	/* clrb */
	    B=0;
	    CC.all &= 0xf4;
	    CC.all |= 0x04;
	    break;
	  case 0x80: case 0x90: case 0xa0: case 0xb0:	/* suba */
/*	    muw=(A&0x0f)+(post.b.a&0x0f);	\* half carry *\
	    CC.bit.h=btst(muw, 4);*/
	    muw=(A&0x7f)+(post.b.a&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    A=muw=A+post.b.a;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!A;
	    break;
	  case 0x81: case 0x91: case 0xa1: case 0xb1:	/* cmpa */
	    CC.bit.v = btst((A&0x7f)+((-post.b.a)&0x7f), 7);
	    CC.bit.c = btst(muw=A-post.b.a, 8);
	    muw &= 0xff;
	    CC.bit.v ^= CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n = btst(muw, 7);
	    CC.bit.z = !muw;
	    break;
	  case 0x82: case 0x92: case 0xa2: case 0xb2:	/* sbca */
/*	    muw=(A&0x0f)+((-post.b.a-CC.bit.c)&0x0f);	\* half carry *\
	    CC.bit.h=btst(muw, 4);*/
	    mul=(A&0x7f)+((-post.b.a-CC.bit.c)&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    A=muw=A-post.b.a-CC.bit.c;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!A;
	    break;
	  case 0x83: case 0x93: case 0xa3: case 0xb3:	/* subd */
	    mul=(D&0x7fff)+((-post.w.a)&0x7fff);	/* carry in */
	    CC.bit.v=btst(mul, 15);
	    D=mul=D-post.w.a;			/* carry out */
	    CC.bit.c=btst(mul, 16);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n=btst(mul, 15);
	    CC.bit.z=!D;
	    break;
	  case 0x84: case 0x94: case 0xa4: case 0xb4:	/* anda */
	    A &= post.b.a;
	    CC.bit.v = 0;
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x85: case 0x95: case 0xa5: case 0xb5:	/* bita */
	    mub = A&post.b.a;
	    CC.bit.n = btst(mub, 7);
	    CC.bit.v = 0;
	    CC.bit.z = !mub;
	    break;
	  case 0x86: case 0x96: case 0xa6: case 0xb6:	/* lda */
	    A=post.b.a;
	    CC.bit.n=btst(A, 7);
	    CC.bit.v=0;
	    CC.bit.z=!A;
	    break;
	  case 0x97: case 0xa7: case 0xb7:	/* sta */
	    memory[post.w.a]=A;
	    CC.bit.v = 0;
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x88: case 0x98: case 0xa8: case 0xb8:	/* eora */
	    A ^= post.b.a;
	    CC.bit.v = 0;
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x89: case 0x99: case 0xa9: case 0xb9:	/* adca */
	    muw=(A&0x0f)+((post.b.a+CC.bit.c)&0x0f);	/* half carry */
	    CC.bit.h=btst(muw, 4);
	    muw=(A&0x7f)+((post.b.a+CC.bit.c)&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    A=muw=A+post.b.a+CC.bit.c;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!A;
	    break;
	  case 0x8a: case 0x9a: case 0xaa: case 0xba:	/* ora */
	    A |= post.b.a;
	    CC.bit.v = 0;
	    CC.bit.n = btst(A, 7);
	    CC.bit.z = !A;
	    break;
	  case 0x8b: case 0x9b: case 0xab: case 0xbb:	/* adda */
	    muw=(A&0x0f)+(post.b.a&0x0f);	/* half carry */
	    CC.bit.h=btst(muw, 4);
	    muw=(A&0x7f)+(post.b.a&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    A=muw=A+post.b.a;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!A;
	    break;
	  case 0x8c: case 0x9c: case 0xac: case 0xbc:	/* cmpx */
	    CC.bit.v = btst((X&0x7fff)+((-post.w.a)&0x7fff), 15);
	    CC.bit.c = btst(mul=X-post.w.a, 16);
	    mul &= 0xffff;
	    CC.bit.v ^= CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n = btst(mul, 15);
	    CC.bit.z = !mul;
	    break;
	  case 0x8d:	/* bsr */
	  case 0x9d: case 0xad: case 0xbd:	/* jsr */
	    wstore(S-=2, PC);
	    PC = post.w.a;
	    break;
	  case 0x8e: case 0x9e: case 0xae: case 0xbe:	/* ldx */
	    X=post.w.a;
	    CC.bit.n=btst(X, 15);
	    CC.bit.v=0;
	    CC.bit.z=!X;
	    break;
	  case 0x9f: case 0xaf: case 0xbf:	/* stx */
	    wstore(post.w.a, X);
	    CC.bit.v = 0;
	    CC.bit.n = btst(X, 15);
	    CC.bit.z = !X;
	    break;
	  case 0xc0: case 0xd0: case 0xe0: case 0xf0:	/* subb */
/*	    muw=(B&0x0f)+((-post.b.a)&0x0f);	\* half carry *\
	    CC.bit.h=btst(muw, 4);*/
	    muw=(B&0x7f)+((-post.b.a)&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    B=muw=B-post.b.a;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!B;
	    break;
	  case 0xc1: case 0xd1: case 0xe1: case 0xf1:	/* cmpb */
	    CC.bit.v = btst((B&0x7f)+((-post.b.a)&0x7f), 7);
	    CC.bit.c = btst(muw=B-post.b.a, 8);
	    muw &= 0xff;
	    CC.bit.v ^= CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n = btst(muw, 7);
	    CC.bit.z = !muw;
	    break;
	  case 0xc2: case 0xd2: case 0xe2: case 0xf2:	/* sbcb */
/*	    muw=(B&0x0f)+((-post.b.a-CC.bit.c)&0x0f);	\* half carry *\
	    CC.bit.h=btst(muw, 4);*/
	    muw=(B&0x7f)+((-post.b.a-CC.bit.c)&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    B=muw=B-post.b.a-CC.bit.c;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.c = !CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!B;
	    break;
	  case 0xc3: case 0xd3: case 0xe3: case 0xf3:	/* addd */
	    mul=(D&0x7fff)+(post.w.a&0x7fff);
	    CC.bit.v=btst(mul, 15);
	    mul=D+post.w.a;
	    CC.bit.c=btst(mul, 16);
	    D=mul;
	    CC.bit.v^=CC.bit.c;
	    CC.bit.n=btst(mul, 15);
	    CC.bit.z=!D;
	    break;
	  case 0xc4: case 0xd4: case 0xe4: case 0xf4:	/* andb */
	    B &= post.b.a;
	    CC.bit.v = 0;
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0xc5: case 0xd5: case 0xe5: case 0xf5:	/* bitb */
	    mub = B&post.b.a;
	    CC.bit.n = btst(mub, 7);
	    CC.bit.v = 0;
	    CC.bit.z = !mub;
	    break;
	  case 0xc6: case 0xd6: case 0xe6: case 0xf6:	/* ldb */
	    B=post.b.a;
	    CC.bit.n=btst(B, 7);
	    CC.bit.v=0;
	    CC.bit.z=!B;
	    break;
	  case 0xd7: case 0xe7: case 0xf7:	/* stb */
	    memory[post.w.a]=B;
	    CC.bit.v = 0;
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0xc8: case 0xd8: case 0xe8: case 0xf8:	/* erob */
	    B ^= post.b.a;
	    CC.bit.v = 0;
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0xc9: case 0xd9: case 0xe9: case 0xf9:	/* adcb */
	    muw=(B&0x0f)+((post.b.a+CC.bit.c)&0x0f);	/* half carry */
	    CC.bit.h=btst(mul, 4);
	    muw=(B&0x7f)+((post.b.a+CC.bit.c)&0x7f);	/* carry in */
	    CC.bit.v=btst(mul, 7);
	    B=muw=B+post.b.a+CC.bit.c;			/* carry out */
	    CC.bit.c=btst(mul, 8);
	    CC.bit.v^=CC.bit.c;
	    CC.bit.n=btst(mul, 7);
	    CC.bit.z=!B;
	    break;
	  case 0xca: case 0xda: case 0xea: case 0xfa:	/* orb */
	    B |= post.b.a;
	    CC.bit.v = 0;
	    CC.bit.n = btst(B, 7);
	    CC.bit.z = !B;
	    break;
	  case 0xcb: case 0xdb: case 0xeb: case 0xfb:	/* addb */
	    muw=(B&0x0f)+(post.b.a&0x0f);	/* half carry */
	    CC.bit.h=btst(muw, 4);
	    muw=(B&0x7f)+(post.b.a&0x7f);	/* carry in */
	    CC.bit.v=btst(muw, 7);
	    muw=B+post.b.a;			/* carry out */
	    CC.bit.c=btst(muw, 8);
	    B=muw;
	    CC.bit.v^=CC.bit.c;
	    CC.bit.n=btst(muw, 7);
	    CC.bit.z=!B;
	    break;
	  case 0xcc: case 0xdc: case 0xec: case 0xfc:	/* ldd */
	    D=post.w.a;
	    CC.bit.n=btst(D, 15);
	    CC.bit.v=0;
	    CC.bit.z=!D;
	    break;
	  case 0xcd:	/* ldq */
	    Q = post.l.a;
	    CC.bit.n=btst(Q, 31);
	    CC.bit.v=0;
	    CC.bit.z=!Q;
	  case 0xdd: case 0xed: case 0xfd:	/* std */
	    wstore(post.w.a, D);
	    CC.bit.v = 0;
	    CC.bit.n = btst(D, 15);
	    CC.bit.z = !D;
	    break;
	  case 0xce: case 0xde: case 0xee: case 0xfe:	/* ldu */
	    U=post.w.a;
	    CC.bit.n=btst(U, 15);
	    CC.bit.v=0;
	    CC.bit.z=!U;
	    break;
	  case 0xdf: case 0xef: case 0xff:	/* stu */
	    wstore(post.w.a, U);
	    CC.bit.v = 0;
	    CC.bit.n = btst(U, 15);
	    CC.bit.z = !U;
	    break;
	  case 0x10:
	    switch(i1) {
	      case 0x21:	/* lbrn */
		break;
	      case 0x22:	/* lbhi */
		if (!(CC.bit.c | CC.bit.z)) PC=post.w.a;
		break;
	      case 0x23:	/* lbls */
		if (CC.bit.c | CC.bit.z) PC=post.w.a;
		break;
	      case 0x24:	/* lbcc */
		if (!CC.bit.c) PC=post.w.a;
		break;
	      case 0x25:
		if (CC.bit.c) PC=post.w.a;
		break;
	      case 0x26:	/* lbne */
		if (!CC.bit.z) PC=post.w.a;
		break;
	      case 0x27:	/* lbeq */
		if (CC.bit.z) PC=post.w.a;
		break;
	      case 0x28:	/* lbvc */
		if (!CC.bit.v) PC=post.w.a;
		break;
	      case 0x29:	/* lbvs */
		if (CC.bit.v) PC=post.w.a;
		break;
	      case 0x2a:	/* lbpl */
		if (!CC.bit.n) PC=post.w.a;
		break;
	      case 0x2b:	/* lbmi */
		if (CC.bit.n) PC=post.w.a;
		break;
	      case 0x2c:	/* lbge */
		if (!(CC.bit.n ^ CC.bit.v)) PC=post.w.a;
		break;
	      case 0x2d:	/* lblt */
		if (CC.bit.n ^ CC.bit.v) PC=post.w.a;
		break;
	      case 0x2e:	/* lbgt */
		if (!(CC.bit.z & (CC.bit.n ^ CC.bit.v))) PC=post.w.a;
		break;
	      case 0x2f:
		if (CC.bit.z & (CC.bit.n ^ CC.bit.v)) PC=post.w.a;
		break;
	      case 0x30:	/* addr */
	      case 0x31:	/* adcr */
	      case 0x32:	/* subr */
	      case 0x33:	/* sbcr */
	      case 0x34:	/* andr */
	      case 0x35:	/* orr */
	      case 0x36:	/* eorr */
	      case 0x37:	/* cmpr */
	      case 0x38:	/* pshsw */
		wstore(S-=2, W);
		break;
	      case 0x39:	/* pulsw */
		W=wfetch((S+=2)-2);
		break;
	      case 0x3a:	/* pshuw */
		wstore(U-=2, W);
		break;
	      case 0x3b:	/* puluw */
		W=wfetch((S+=2)-2);
		break;
	      case 0x3f:	/* swi2 */
		CC.bit.e = 1;
		wstore(S-=2, PC);
		wstore(S-=2, U);
		wstore(S-=2, Y);
		wstore(S-=2, X);
		memory[--S]=DP;
		if (MD.bit.em) wstore(S-=2, W);
		memory[--S]=B;
		memory[--S]=A;
		memory[--S]=CC.all;
		CC.bit.f = CC.bit.i = 1;
		PC = wfetch(0xfff4);
		break;
	      case 0x40:	/* negd */
	      case 0x43:	/* comd */
	      case 0x44:	/* lsrd */
	      case 0x46:	/* rord */
	      case 0x47:	/* asrd */
	      case 0x48:	/* asld */
	      case 0x49:	/* rold */
	      case 0x4a:	/* decd */
	      case 0x4c:	/* incd */
	      case 0x4d:	/* tstd */
	      case 0x4f:	/* clrd */
/*	      case 0x50:	\* negw *\ */
	      case 0x53:	/* comw */
	      case 0x54:	/* lsrw */
	      case 0x56:	/* rorw */
	      case 0x57:	/* asrw */
	      case 0x58:	/* aslw */
	      case 0x59:	/* rolw */
	      case 0x5a:	/* decw */
	      case 0x5c:	/* incw */
	      case 0x5d:	/* tstw */
	      case 0x5f:	/* clrw */
	      case 0x83: case 0x93: case 0xa3: case 0xb3:	/* cmpd */
		CC.bit.v = btst((D&0x7fff)+((-post.w.a)&0x7fff), 15);
		CC.bit.c = btst(mul=D-post.w.a, 16);
		mul &= 0xffff;
		CC.bit.v ^= CC.bit.c;
		CC.bit.c = !CC.bit.c;
		CC.bit.n = btst(mul, 15);
		CC.bit.z = !mul;
		break;
	      case 0x8c: case 0x9c: case 0xac: case 0xbc:	/* cmpy */
		CC.bit.v = btst((Y&0x7fff)+((-post.w.a)&0x7fff), 15);
		CC.bit.c = btst(mul=Y-post.w.a, 16);
		mul &= 0xffff;
		CC.bit.v ^= CC.bit.c;
		CC.bit.c = !CC.bit.c;
		CC.bit.n = btst(mul, 15);
		CC.bit.z = !mul;
		break;
	      case 0x8e: case 0x9e: case 0xae: case 0xbe:	/* ldy */
		Y=post.w.a;
		CC.bit.n=btst(Y, 15);
		CC.bit.v=0;
		CC.bit.z=!Y;
		break;
	      case 0x9f: case 0xaf: case 0xbf:	/* sty */
		wstore(post.w.a, Y);
		CC.bit.v = 0;
		CC.bit.n = btst(Y, 15);
		CC.bit.z = !Y;
		break;
	      case 0xce: case 0xde: case 0xee: case 0xfe:	/* lds */
		S=post.w.a;
		CC.bit.n=btst(S, 15);
		CC.bit.v=0;
		CC.bit.z=!S;
		break;
	      case 0xdf: case 0xef: case 0xff:	/* sts */
		wstore(post.w.a, S);
		CC.bit.v = 0;
		CC.bit.n = btst(S, 15);
		CC.bit.z = !S;
		break;
	      default:
		if (mode==UNIM)
		    unimp("unknown");
		else
		    fprintf(stderr, "Unimplemented Instruction 10%02X\n", i1);
	    }
	    break;
	  case 0x11:
	    switch(i1) {
	      case 0x3f:	/* swi3 */
		CC.bit.e = 1;
		wstore(S-=2, PC);
		wstore(S-=2, U);
		wstore(S-=2, Y);
		wstore(S-=2, X);
		memory[--S]=DP;
		if (MD.bit.em) wstore(S-=2, W);
		memory[--S]=B;
		memory[--S]=A;
		memory[--S]=CC.all;
		CC.bit.f = CC.bit.i = 1;
		PC = wfetch(0xfff2);
		break;
	      case 0x83: case 0x93: case 0xa3: case 0xb3:	/* cmpu */
		CC.bit.v = btst((U&0x7fff)+((-post.w.a)&0x7fff), 15);
		CC.bit.c = btst(mul=U-post.w.a, 16);
		mul &= 0xffff;
		CC.bit.v ^= CC.bit.c;
		CC.bit.c = !CC.bit.c;
		CC.bit.n = btst(mul, 15);
		CC.bit.z = !mul;
		break;
	      case 0x8c: case 0x9c: case 0xac: case 0xbc:	/* cmps */
		CC.bit.v = btst((S&0x7fff)+((-post.w.a)&0x7fff), 15);
		CC.bit.c = btst(mul=S-post.w.a, 16);
		mul &= 0xffff;
		CC.bit.v ^= CC.bit.c;
		CC.bit.c = !CC.bit.c;
		CC.bit.n = btst(mul, 15);
		CC.bit.z = !mul;
		break;
	      default:
		if (mode==UNIM)
		    unimp("unknown");
		else
		    fprintf(stderr, "Unimplemented Instruction 11%02X\n", i1);
	    }
	    break;
	  default:
	    if (mode==UNIM)
		unimp("unknown");
	    else
		fprintf(stderr, "Unimplemented Instruction %02X\n", i0);
	}
    }
}

state()
{
    printf("A  : %02X %d\tB  : %02X %d\tE  : %02X %d\tF  : %02X %d\n", A, A, B, B, E, E, F, F);
    printf("D  : %04X %d\tW  : %04X %d\n", D, D, W, W);
    printf("Q  : %08X %d\n", Q, Q);
    printf("V  : %04X %d\n", V, V);
    printf("X  : %04X %d\tY  : %04X %d\n", X, X, Y, Y);
    printf("S  : %04X %d\tU  : %04X %d\n", S, S, U, U);
    printf("PC : %04X\tDP : %02X\n", PC, DP);
    printf("        CVZNIHFE\n");
    printf("CC : %02X %d%d%d%d%d%d%d%d\n", CC.all, CC.bit.c, CC.bit.v, CC.bit.z, CC.bit.n, CC.bit.i, CC.bit.h, CC.bit.f, CC.bit.e);
    printf("        ZI----FE\n");
    printf("MD : %02X %d%d----%d%d\n", MD.all, MD.bit.dz, MD.bit.ii, MD.bit.fm, MD.bit.em);
}

unimp(s)
char *s;
{
    fprintf(stderr, "%s: is unimplemented\n", s);
    MD.bit.ii = 1;
    MD.bit.dz = 0;
    PC = memory[0xfff0]<<8 | memory[0xfff1];
}
